#!/usr/bin/env python

# Copyright 2004 Tom Rothamel <pytom@bishoujo.us>
# 
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
# 
# 
import renpy
import os.path
from cPickle import loads
from cStringIO import StringIO

archives = [ ]

def index_archives():
    """
    Loads in the indexes for the archive files.
    """

    global archives
    archives = [ ]

    for prefix in renpy.config.archives:
        fn = transfn(prefix + ".rpi")
        index = loads(file(fn, "rb").read().decode("zlib")) 

        print index.keys()

        archives.append((prefix, index))

def load(name):
    """
    Returns an open python file object of the given type.
    """

    # Look for the file directly.
    fn = transfn(name)
    if os.path.exists(fn):
        return file(fn, "rb")

    # Look for it in archive files.
    for prefix, index in archives:
        if not name in index:
            continue

        offset, dlen = index[name]

        f = file(transfn(prefix + ".rpa"), "rb")
        f.seek(offset)
        rv = StringIO(f.read(dlen))
        f.close()

        return rv

    raise Exception("Couldn't find file '%s'." % name)

def transfn(name):
    return renpy.game.basepath + "/" + name
